
///    (Brenkman Andrey)
///   5.12.2008 19.11.2009
///    80%

#include "gcc-compat.h"

#include "a_position_struct.h"

/// -(1-0)      
#define TEST_F 0;

///!
///         
///   #if #endif
/// unexpected tokens following preprocessor directive - expected a newline
#pragma warning(disable : 4067) 

/*

Quiescence search
http://chessprogramming.wikispaces.com/Quiescence+Search

Virtually all chess programs, at the end of the main search perform 
a more limited quiescence search, containing fewer moves. 
The purpose of this search is to only evaluate "quiet" positions, 
or positions where there are no winning tactical moves to be made. 
This search is needed to avoid the horizon effect. Simply stopping 
your search when you reach the desired depth and then evaluate, 
is very dangerous. Consider the situation where the last move 
you consider is QxP. If you stop there and evaluate, you might 
think that you have won a pawn. But what if you were to search one 
move deeper and find that the next move is PxQ? You didn't win a pawn, 
you actually lost a queen. Hence the need to make sure that you are 
evaluating only quiescent (quiet) positions.

Pseudo Code
int Quiesce( int alpha, int beta ) {
    int stand_pat = Evaluate();
    if( stand_pat >= beta )
        return beta;
    if( alpha < stand_pat )
        alpha = stand_pat;
 
    until( every_capture_has_been_examined )  {
        MakeCapture();
        score = -Quiesce( -beta, -alpha );
        TakeBackMove();
 
        if( score >= beta )
            return beta;
        if( score > alpha )
           alpha = score;
    }
    return alpha;
}

end link( )---------------------
*/

/*
    
        :
    
  delta pruning
*/

namespace Search_quiescence
{

//////////////////////////////////////////////////////////////////////////////////////
//public:

	///---------------------------------------------------------------------------
	///     
	int32_t forced_variant_white
	(
		struct Position & position,///  
		int32_t alpha,///
		const int32_t beta,///
		const uint8_t depth,/// 
		const bool flag_pv_f///     (pv)
	);

	///---------------------------------------------------------------------------
	///     
	int32_t forced_variant_black
	(
		struct Position & position,///  
		const int32_t alpha,///
		int32_t beta,///
		const uint8_t depth,/// 
		const bool flag_pv_f///     (pv)
	);

	///---------------------------------------------------------------------------
	///TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
	///  
	///  , 


};


namespace DELTA_PRUNING_CONSTANTS
{
	const uint16_t QUEEN_MARGIN = (QUEEN + 2 * PAWN); ///   
	const uint16_t ROOK_MARGIN = (ROOK + 2 * PAWN); ///   
	const uint16_t MAX_BISHOP_KNIGHT_MARGIN = (BISHOP > KNIGHT) ? (BISHOP + (2 * PAWN)) : (KNIGHT + (2 * PAWN)) ; ///      
	const uint16_t PAWN_MARGIN = PAWN + (2 * PAWN); ///    

}

using namespace DELTA_PRUNING_CONSTANTS;